#ifndef WIN32
#include <unistd.h>
#endif
#include <stdio.h>
#include <GL/freeglut.h>
#include <GL/freeglut_std.h>
#include <GL/freeglut_ext.h>
#include <mui/mui.h>

/* How many signals can return from 1 iteration */
#define MAX_RETURNED_CALLBACKS 256

enum funcs {
	myglutDisplayFunc1,				/* 1 */
	myglutDisplayFunc2,
	myglutDisplayFunc3,
	myglutDisplayFunc4,
	myglutDisplayFunc5,
	myglutDisplayFunc6,
	myglutDisplayFunc7,
	myglutDisplayFunc8,
	myglutOverlayDisplayFunc1,		/* 2 */
	myglutOverlayDisplayFunc2,
	myglutOverlayDisplayFunc3,
	myglutOverlayDisplayFunc4,
	myglutOverlayDisplayFunc5,
	myglutOverlayDisplayFunc6,
	myglutOverlayDisplayFunc7,
	myglutOverlayDisplayFunc8,
	myglutReshapeFunc1,				/* 3 */
	myglutReshapeFunc2,
	myglutReshapeFunc3,
	myglutReshapeFunc4,
	myglutReshapeFunc5,
	myglutReshapeFunc6,
	myglutReshapeFunc7,
	myglutReshapeFunc8,
	myglutKeyboardFunc1,			/* 4 */
	myglutKeyboardFunc2,
	myglutKeyboardFunc3,
	myglutKeyboardFunc4,
	myglutKeyboardFunc5,
	myglutKeyboardFunc6,
	myglutKeyboardFunc7,
	myglutKeyboardFunc8,
	myglutMouseFunc1,				/* 5 */
	myglutMouseFunc2,
	myglutMouseFunc3,
	myglutMouseFunc4,
	myglutMouseFunc5,
	myglutMouseFunc6,
	myglutMouseFunc7,
	myglutMouseFunc8,
	myglutMotionFunc1,				/* 6 */
	myglutMotionFunc2,
	myglutMotionFunc3,
	myglutMotionFunc4,
	myglutMotionFunc5,
	myglutMotionFunc6,
	myglutMotionFunc7,
	myglutMotionFunc8,
	myglutPassiveMotionFunc1,		/* 7 */
	myglutPassiveMotionFunc2,
	myglutPassiveMotionFunc3,
	myglutPassiveMotionFunc4,
	myglutPassiveMotionFunc5,
	myglutPassiveMotionFunc6,
	myglutPassiveMotionFunc7,
	myglutPassiveMotionFunc8,
	myglutVisibilityFunc1,			/* 8 */
	myglutVisibilityFunc2,
	myglutVisibilityFunc3,
	myglutVisibilityFunc4,
	myglutVisibilityFunc5,
	myglutVisibilityFunc6,
	myglutVisibilityFunc7,
	myglutVisibilityFunc8,
	myglutEntryFunc1,				/* 9 */
	myglutEntryFunc2,
	myglutEntryFunc3,
	myglutEntryFunc4,
	myglutEntryFunc5,
	myglutEntryFunc6,
	myglutEntryFunc7,
	myglutEntryFunc8,
	myglutSpecialFunc1,				/* 10 */
	myglutSpecialFunc2,
	myglutSpecialFunc3,
	myglutSpecialFunc4,
	myglutSpecialFunc5,
	myglutSpecialFunc6,
	myglutSpecialFunc7,
	myglutSpecialFunc8,
	myglutSpaceballMotionFunc1,		/* 11 */
	myglutSpaceballMotionFunc2,
	myglutSpaceballMotionFunc3,
	myglutSpaceballMotionFunc4,
	myglutSpaceballMotionFunc5,
	myglutSpaceballMotionFunc6,
	myglutSpaceballMotionFunc7,
	myglutSpaceballMotionFunc8,
	myglutSpaceballRotateFunc1,		/* 12 */
	myglutSpaceballRotateFunc2,
	myglutSpaceballRotateFunc3,
	myglutSpaceballRotateFunc4,
	myglutSpaceballRotateFunc5,
	myglutSpaceballRotateFunc6,
	myglutSpaceballRotateFunc7,
	myglutSpaceballRotateFunc8,
	myglutSpaceballButtonFunc1,		/* 13 */
	myglutSpaceballButtonFunc2,
	myglutSpaceballButtonFunc3,
	myglutSpaceballButtonFunc4,
	myglutSpaceballButtonFunc5,
	myglutSpaceballButtonFunc6,
	myglutSpaceballButtonFunc7,
	myglutSpaceballButtonFunc8,
	myglutButtonBoxFunc1,			/* 14 */
	myglutButtonBoxFunc2,
	myglutButtonBoxFunc3,
	myglutButtonBoxFunc4,
	myglutButtonBoxFunc5,
	myglutButtonBoxFunc6,
	myglutButtonBoxFunc7,
	myglutButtonBoxFunc8,
	myglutDialsFunc1,				/* 15 */
	myglutDialsFunc2,
	myglutDialsFunc3,
	myglutDialsFunc4,
	myglutDialsFunc5,
	myglutDialsFunc6,
	myglutDialsFunc7,
	myglutDialsFunc8,
	myglutTabletMotionFunc1,		/* 16 */
	myglutTabletMotionFunc2,
	myglutTabletMotionFunc3,
	myglutTabletMotionFunc4,
	myglutTabletMotionFunc5,
	myglutTabletMotionFunc6,
	myglutTabletMotionFunc7,
	myglutTabletMotionFunc8,
	myglutTabletButtonFunc1,		/* 17 */
	myglutTabletButtonFunc2,
	myglutTabletButtonFunc3,
	myglutTabletButtonFunc4,
	myglutTabletButtonFunc5,
	myglutTabletButtonFunc6,
	myglutTabletButtonFunc7,
	myglutTabletButtonFunc8,
	myglutTimerFunc1,				/* 18 */
	myglutTimerFunc2,
	myglutTimerFunc3,
	myglutTimerFunc4,
	myglutTimerFunc5,
	myglutTimerFunc6,
	myglutTimerFunc7,
	myglutTimerFunc8,
	myglutCreateMenu1,				/* 19 */
	myglutCreateMenu2,
	myglutCreateMenu3,
	myglutCreateMenu4,
	myglutCreateMenu5,
	myglutCreateMenu6,
	myglutCreateMenu7,
	myglutCreateMenu8,
	myglutMenuStatusFunc,			/* 20 */
	myglutMenuStateFunc,			/* 21 */
	myglutIdleFunc,					/* 22 -> will not index */
	mymuiSetNonMUIcallback,			/* 23 */
	mymuiSetCallback1,				/* 24 */
	mymuiSetCallback2,
	mymuiSetCallback3,
	mymuiSetCallback4,
	mymuiSetCallback5,
	mymuiSetCallback6,
	mymuiSetCallback7,
	mymuiSetCallback8,
	mymuiSetCallback9,
	mymuiSetCallback10,
	mymuiSetCallback11,
	mymuiSetCallback12,
	mymuiSetCallback13,
	mymuiSetCallback14,
	mymuiSetCallback15,
	mymuiSetCallback16,
	mymuiSetCallback17,
	mymuiSetCallback18,
	mymuiSetCallback19,
	mymuiSetCallback20,
	mymuiSetCallback21,
	mymuiSetCallback22,
	mymuiSetCallback23,
	mymuiSetCallback24,
	mymuiSetCallback25,
	mymuiSetCallback26,
	mymuiSetCallback27,
	mymuiSetCallback28,
	mymuiSetCallback29,
	mymuiSetCallback30,
	mymuiSetCallback31,
	mymuiSetCallback32,
	myglutMouseWheelFunc1,				/* 25 */
	myglutMouseWheelFunc2,
	myglutMouseWheelFunc3,
	myglutMouseWheelFunc4,
	myglutMouseWheelFunc5,
	myglutMouseWheelFunc6,
	myglutMouseWheelFunc7,
	myglutMouseWheelFunc8,
	myglutJoystickFunc1,				/* 26 */
	myglutJoystickFunc2,
	myglutJoystickFunc3,
	myglutJoystickFunc4,
	myglutJoystickFunc5,
	myglutJoystickFunc6,
	myglutJoystickFunc7,
	myglutJoystickFunc8
};

/* There is space for 8 callbacks */
void glutDisplayFunc_callback1();
void glutDisplayFunc_callback2();
void glutDisplayFunc_callback3();
void glutDisplayFunc_callback4();
void glutDisplayFunc_callback5();
void glutDisplayFunc_callback6();
void glutDisplayFunc_callback7();
void glutDisplayFunc_callback8();
void glutOverlayDisplayFunc_callback1();
void glutOverlayDisplayFunc_callback2();
void glutOverlayDisplayFunc_callback3();
void glutOverlayDisplayFunc_callback4();
void glutOverlayDisplayFunc_callback5();
void glutOverlayDisplayFunc_callback6();
void glutOverlayDisplayFunc_callback7();
void glutOverlayDisplayFunc_callback8();
void glutReshapeFunc_callback1();
void glutReshapeFunc_callback2();
void glutReshapeFunc_callback3();
void glutReshapeFunc_callback4();
void glutReshapeFunc_callback5();
void glutReshapeFunc_callback6();
void glutReshapeFunc_callback7();
void glutReshapeFunc_callback8();
void glutKeyboardFunc_callback1();
void glutKeyboardFunc_callback2();
void glutKeyboardFunc_callback3();
void glutKeyboardFunc_callback4();
void glutKeyboardFunc_callback5();
void glutKeyboardFunc_callback6();
void glutKeyboardFunc_callback7();
void glutKeyboardFunc_callback8();
void glutMouseFunc_callback1();
void glutMouseFunc_callback2();
void glutMouseFunc_callback3();
void glutMouseFunc_callback4();
void glutMouseFunc_callback5();
void glutMouseFunc_callback6();
void glutMouseFunc_callback7();
void glutMouseFunc_callback8();
void glutMotionFunc_callback1();
void glutMotionFunc_callback2();
void glutMotionFunc_callback3();
void glutMotionFunc_callback4();
void glutMotionFunc_callback5();
void glutMotionFunc_callback6();
void glutMotionFunc_callback7();
void glutMotionFunc_callback8();
void glutPassiveMotionFunc_callback1();
void glutPassiveMotionFunc_callback2();
void glutPassiveMotionFunc_callback3();
void glutPassiveMotionFunc_callback4();
void glutPassiveMotionFunc_callback5();
void glutPassiveMotionFunc_callback6();
void glutPassiveMotionFunc_callback7();
void glutPassiveMotionFunc_callback8();
void glutVisibilityFunc_callback1();
void glutVisibilityFunc_callback2();
void glutVisibilityFunc_callback3();
void glutVisibilityFunc_callback4();
void glutVisibilityFunc_callback5();
void glutVisibilityFunc_callback6();
void glutVisibilityFunc_callback7();
void glutVisibilityFunc_callback8();
void glutEntryFunc_callback1();
void glutEntryFunc_callback2();
void glutEntryFunc_callback3();
void glutEntryFunc_callback4();
void glutEntryFunc_callback5();
void glutEntryFunc_callback6();
void glutEntryFunc_callback7();
void glutEntryFunc_callback8();
void glutSpecialFunc_callback1();
void glutSpecialFunc_callback2();
void glutSpecialFunc_callback3();
void glutSpecialFunc_callback4();
void glutSpecialFunc_callback5();
void glutSpecialFunc_callback6();
void glutSpecialFunc_callback7();
void glutSpecialFunc_callback8();
void glutSpaceballMotionFunc_callback1();
void glutSpaceballMotionFunc_callback2();
void glutSpaceballMotionFunc_callback3();
void glutSpaceballMotionFunc_callback4();
void glutSpaceballMotionFunc_callback5();
void glutSpaceballMotionFunc_callback6();
void glutSpaceballMotionFunc_callback7();
void glutSpaceballMotionFunc_callback8();
void glutSpaceballRotateFunc_callback1();
void glutSpaceballRotateFunc_callback2();
void glutSpaceballRotateFunc_callback3();
void glutSpaceballRotateFunc_callback4();
void glutSpaceballRotateFunc_callback5();
void glutSpaceballRotateFunc_callback6();
void glutSpaceballRotateFunc_callback7();
void glutSpaceballRotateFunc_callback8();
void glutSpaceballButtonFunc_callback1();
void glutSpaceballButtonFunc_callback2();
void glutSpaceballButtonFunc_callback3();
void glutSpaceballButtonFunc_callback4();
void glutSpaceballButtonFunc_callback5();
void glutSpaceballButtonFunc_callback6();
void glutSpaceballButtonFunc_callback7();
void glutSpaceballButtonFunc_callback8();
void glutButtonBoxFunc_callback1();
void glutButtonBoxFunc_callback2();
void glutButtonBoxFunc_callback3();
void glutButtonBoxFunc_callback4();
void glutButtonBoxFunc_callback5();
void glutButtonBoxFunc_callback6();
void glutButtonBoxFunc_callback7();
void glutButtonBoxFunc_callback8();
void glutDialsFunc_callback1();
void glutDialsFunc_callback2();
void glutDialsFunc_callback3();
void glutDialsFunc_callback4();
void glutDialsFunc_callback5();
void glutDialsFunc_callback6();
void glutDialsFunc_callback7();
void glutDialsFunc_callback8();
void glutTabletMotionFunc_callback1();
void glutTabletMotionFunc_callback2();
void glutTabletMotionFunc_callback3();
void glutTabletMotionFunc_callback4();
void glutTabletMotionFunc_callback5();
void glutTabletMotionFunc_callback6();
void glutTabletMotionFunc_callback7();
void glutTabletMotionFunc_callback8();
void glutTabletButtonFunc_callback1();
void glutTabletButtonFunc_callback2();
void glutTabletButtonFunc_callback3();
void glutTabletButtonFunc_callback4();
void glutTabletButtonFunc_callback5();
void glutTabletButtonFunc_callback6();
void glutTabletButtonFunc_callback7();
void glutTabletButtonFunc_callback8();
void glutTimerFunc_callback1();
void glutTimerFunc_callback2();
void glutTimerFunc_callback3();
void glutTimerFunc_callback4();
void glutTimerFunc_callback5();
void glutTimerFunc_callback6();
void glutTimerFunc_callback7();
void glutTimerFunc_callback8();
void glutCreateMenu_callback1();
void glutCreateMenu_callback2();
void glutCreateMenu_callback3();
void glutCreateMenu_callback4();
void glutCreateMenu_callback5();
void glutCreateMenu_callback6();
void glutCreateMenu_callback7();
void glutCreateMenu_callback8();
void muiSetNonMUIcallback_callback();
/* MUI has 32 callbacks */
void muiSetCallback_callback1();
void muiSetCallback_callback2();
void muiSetCallback_callback3();
void muiSetCallback_callback4();
void muiSetCallback_callback5();
void muiSetCallback_callback6();
void muiSetCallback_callback7();
void muiSetCallback_callback8();
void muiSetCallback_callback9();
void muiSetCallback_callback10();
void muiSetCallback_callback11();
void muiSetCallback_callback12();
void muiSetCallback_callback13();
void muiSetCallback_callback14();
void muiSetCallback_callback15();
void muiSetCallback_callback16();
void muiSetCallback_callback17();
void muiSetCallback_callback18();
void muiSetCallback_callback19();
void muiSetCallback_callback20();
void muiSetCallback_callback21();
void muiSetCallback_callback22();
void muiSetCallback_callback23();
void muiSetCallback_callback24();
void muiSetCallback_callback25();
void muiSetCallback_callback26();
void muiSetCallback_callback27();
void muiSetCallback_callback28();
void muiSetCallback_callback29();
void muiSetCallback_callback30();
void muiSetCallback_callback31();
void muiSetCallback_callback32();
void glutMouseWheelFunc_callback1();
void glutMouseWheelFunc_callback2();
void glutMouseWheelFunc_callback3();
void glutMouseWheelFunc_callback4();
void glutMouseWheelFunc_callback5();
void glutMouseWheelFunc_callback6();
void glutMouseWheelFunc_callback7();
void glutMouseWheelFunc_callback8();
void glutJoystickFunc_callback1();
void glutJoystickFunc_callback2();
void glutJoystickFunc_callback3();
void glutJoystickFunc_callback4();
void glutJoystickFunc_callback5();
void glutJoystickFunc_callback6();
void glutJoystickFunc_callback7();
void glutJoystickFunc_callback8();

/* Arrays with callback functions go here */
void* display_callbacks[] = {
	(void*)(glutDisplayFunc_callback1),
	(void*)(glutDisplayFunc_callback2),
	(void*)(glutDisplayFunc_callback3),
	(void*)(glutDisplayFunc_callback4),
	(void*)(glutDisplayFunc_callback5),
	(void*)(glutDisplayFunc_callback6),
	(void*)(glutDisplayFunc_callback7),
	(void*)(glutDisplayFunc_callback8)
};
int display_counter = 0;			/* Counter: total defined display callbacks */

void* overlaydisplay_callbacks[] = {
	(void*)(glutOverlayDisplayFunc_callback1),
	(void*)(glutOverlayDisplayFunc_callback2),
	(void*)(glutOverlayDisplayFunc_callback3),
	(void*)(glutOverlayDisplayFunc_callback4),
	(void*)(glutOverlayDisplayFunc_callback5),
	(void*)(glutOverlayDisplayFunc_callback6),
	(void*)(glutOverlayDisplayFunc_callback7),
	(void*)(glutOverlayDisplayFunc_callback8)
};
int overlaydisplay_counter = 0;			/* Counter: total defined display callbacks */

void* reshape_callbacks[] = {
	(void*)(glutReshapeFunc_callback1),
	(void*)(glutReshapeFunc_callback2),
	(void*)(glutReshapeFunc_callback3),
	(void*)(glutReshapeFunc_callback4),
	(void*)(glutReshapeFunc_callback5),
	(void*)(glutReshapeFunc_callback6),
	(void*)(glutReshapeFunc_callback7),
	(void*)(glutReshapeFunc_callback8)
};
int reshape_counter = 0;			/* Counter: total defined reshape callbacks */

void* keyboard_callbacks[] = {
	(void*)(glutKeyboardFunc_callback1),
	(void*)(glutKeyboardFunc_callback2),
	(void*)(glutKeyboardFunc_callback3),
	(void*)(glutKeyboardFunc_callback4),
	(void*)(glutKeyboardFunc_callback5),
	(void*)(glutKeyboardFunc_callback6),
	(void*)(glutKeyboardFunc_callback7),
	(void*)(glutKeyboardFunc_callback8)
};
int keyboard_counter = 0;

void* mouse_callbacks[] = {
	(void*)(glutMouseFunc_callback1),
	(void*)(glutMouseFunc_callback2),
	(void*)(glutMouseFunc_callback3),
	(void*)(glutMouseFunc_callback4),
	(void*)(glutMouseFunc_callback5),
	(void*)(glutMouseFunc_callback6),
	(void*)(glutMouseFunc_callback7),
	(void*)(glutMouseFunc_callback8)
};
int mouse_counter = 0;

void *motion_callbacks[] = {
	(void*)(glutMotionFunc_callback1),
	(void*)(glutMotionFunc_callback2),
	(void*)(glutMotionFunc_callback3),
	(void*)(glutMotionFunc_callback4),
	(void*)(glutMotionFunc_callback5),
	(void*)(glutMotionFunc_callback6),
	(void*)(glutMotionFunc_callback7),
	(void*)(glutMotionFunc_callback8)
};
int motion_counter = 0;

void *passivemotion_callbacks[] = {
	(void*)(glutPassiveMotionFunc_callback1),
	(void*)(glutPassiveMotionFunc_callback2),
	(void*)(glutPassiveMotionFunc_callback3),
	(void*)(glutPassiveMotionFunc_callback4),
	(void*)(glutPassiveMotionFunc_callback5),
	(void*)(glutPassiveMotionFunc_callback6),
	(void*)(glutPassiveMotionFunc_callback7),
	(void*)(glutPassiveMotionFunc_callback8)
};
int passivemotion_counter = 0;

void* visibility_callbacks[] = {
	(void*)(glutVisibilityFunc_callback1),
	(void*)(glutVisibilityFunc_callback2),
	(void*)(glutVisibilityFunc_callback3),
	(void*)(glutVisibilityFunc_callback4),
	(void*)(glutVisibilityFunc_callback5),
	(void*)(glutVisibilityFunc_callback6),
	(void*)(glutVisibilityFunc_callback7),
	(void*)(glutVisibilityFunc_callback8)
};
int visibility_counter = 0;

void *entry_callbacks[] = {
	(void*)(glutEntryFunc_callback1),
	(void*)(glutEntryFunc_callback2),
	(void*)(glutEntryFunc_callback3),
	(void*)(glutEntryFunc_callback4),
	(void*)(glutEntryFunc_callback5),
	(void*)(glutEntryFunc_callback6),
	(void*)(glutEntryFunc_callback7),
	(void*)(glutEntryFunc_callback8)
};
int entry_counter = 0;

void* special_callbacks[] = {
	(void*)(glutSpecialFunc_callback1),
	(void*)(glutSpecialFunc_callback2),
	(void*)(glutSpecialFunc_callback3),
	(void*)(glutSpecialFunc_callback4),
	(void*)(glutSpecialFunc_callback5),
	(void*)(glutSpecialFunc_callback6),
	(void*)(glutSpecialFunc_callback7),
	(void*)(glutSpecialFunc_callback8)
};
int special_counter = 0;

void* spaceballmotion_callbacks[] = {
	(void*)(glutSpaceballMotionFunc_callback1),
	(void*)(glutSpaceballMotionFunc_callback2),
	(void*)(glutSpaceballMotionFunc_callback3),
	(void*)(glutSpaceballMotionFunc_callback4),
	(void*)(glutSpaceballMotionFunc_callback5),
	(void*)(glutSpaceballMotionFunc_callback6),
	(void*)(glutSpaceballMotionFunc_callback7),
	(void*)(glutSpaceballMotionFunc_callback8)
};
int spaceballmotion_counter = 0;

void* spaceballrotate_callbacks[] = {
	(void*)(glutSpaceballRotateFunc_callback1),
	(void*)(glutSpaceballRotateFunc_callback2),
	(void*)(glutSpaceballRotateFunc_callback3),
	(void*)(glutSpaceballRotateFunc_callback4),
	(void*)(glutSpaceballRotateFunc_callback5),
	(void*)(glutSpaceballRotateFunc_callback6),
	(void*)(glutSpaceballRotateFunc_callback7),
	(void*)(glutSpaceballRotateFunc_callback8)
};
int spaceballrotation_counter = 0;

void* spaceballbutton_callbacks[] = {
	(void*)(glutSpaceballButtonFunc_callback1),
	(void*)(glutSpaceballButtonFunc_callback2),
	(void*)(glutSpaceballButtonFunc_callback3),
	(void*)(glutSpaceballButtonFunc_callback4),
	(void*)(glutSpaceballButtonFunc_callback5),
	(void*)(glutSpaceballButtonFunc_callback6),
	(void*)(glutSpaceballButtonFunc_callback7),
	(void*)(glutSpaceballButtonFunc_callback8)
};
int spaceballbutton_counter = 0;

void* buttonbox_callbacks[] = {
	(void*)(glutButtonBoxFunc_callback1),
	(void*)(glutButtonBoxFunc_callback2),
	(void*)(glutButtonBoxFunc_callback3),
	(void*)(glutButtonBoxFunc_callback4),
	(void*)(glutButtonBoxFunc_callback5),
	(void*)(glutButtonBoxFunc_callback6),
	(void*)(glutButtonBoxFunc_callback7),
	(void*)(glutButtonBoxFunc_callback8)
};
int buttonbox_counter = 0;

void* dials_callbacks[] = {
	(void*)(glutDialsFunc_callback1),
	(void*)(glutDialsFunc_callback2),
	(void*)(glutDialsFunc_callback3),
	(void*)(glutDialsFunc_callback4),
	(void*)(glutDialsFunc_callback5),
	(void*)(glutDialsFunc_callback6),
	(void*)(glutDialsFunc_callback7),
	(void*)(glutDialsFunc_callback8)
};
int dials_counter = 0;

void* tabletmotion_callbacks[] = {
	(void*)(glutTabletMotionFunc_callback1),
	(void*)(glutTabletMotionFunc_callback2),
	(void*)(glutTabletMotionFunc_callback3),
	(void*)(glutTabletMotionFunc_callback4),
	(void*)(glutTabletMotionFunc_callback5),
	(void*)(glutTabletMotionFunc_callback6),
	(void*)(glutTabletMotionFunc_callback7),
	(void*)(glutTabletMotionFunc_callback8)
};
int tabletmotion_counter = 0;

void* tabletbutton_callbacks[] = {
	(void*)(glutTabletButtonFunc_callback1),
	(void*)(glutTabletButtonFunc_callback2),
	(void*)(glutTabletButtonFunc_callback3),
	(void*)(glutTabletButtonFunc_callback4),
	(void*)(glutTabletButtonFunc_callback5),
	(void*)(glutTabletButtonFunc_callback6),
	(void*)(glutTabletButtonFunc_callback7),
	(void*)(glutTabletButtonFunc_callback8)
};
int tabletbutton_counter = 0;

void* timer_callbacks[] = {
	(void*)(glutTimerFunc_callback1),
	(void*)(glutTimerFunc_callback2),
	(void*)(glutTimerFunc_callback3),
	(void*)(glutTimerFunc_callback4),
	(void*)(glutTimerFunc_callback5),
	(void*)(glutTimerFunc_callback6),
	(void*)(glutTimerFunc_callback7),
	(void*)(glutTimerFunc_callback8)
};
int timer_counter = 0;

void* menu_callbacks[] = {
	(void*)(glutCreateMenu_callback1),
	(void*)(glutCreateMenu_callback2),
	(void*)(glutCreateMenu_callback3),
	(void*)(glutCreateMenu_callback4),
	(void*)(glutCreateMenu_callback5),
	(void*)(glutCreateMenu_callback6),
	(void*)(glutCreateMenu_callback7),
	(void*)(glutCreateMenu_callback8)
};
int menu_list [7];					/* Keep track of created menus */
int menu_counter = 0;				/* Counter: total defined menus */

void* mui_callbacks[] = {
	(void*)(muiSetCallback_callback1),
	(void*)(muiSetCallback_callback2),
	(void*)(muiSetCallback_callback3),
	(void*)(muiSetCallback_callback4),
	(void*)(muiSetCallback_callback5),
	(void*)(muiSetCallback_callback6),
	(void*)(muiSetCallback_callback7),
	(void*)(muiSetCallback_callback8),
	(void*)(muiSetCallback_callback9),
	(void*)(muiSetCallback_callback10),
	(void*)(muiSetCallback_callback11),
	(void*)(muiSetCallback_callback12),
	(void*)(muiSetCallback_callback13),
	(void*)(muiSetCallback_callback14),
	(void*)(muiSetCallback_callback15),
	(void*)(muiSetCallback_callback16),
	(void*)(muiSetCallback_callback17),
	(void*)(muiSetCallback_callback18),
	(void*)(muiSetCallback_callback19),
	(void*)(muiSetCallback_callback20),
	(void*)(muiSetCallback_callback21),
	(void*)(muiSetCallback_callback22),
	(void*)(muiSetCallback_callback23),
	(void*)(muiSetCallback_callback24),
	(void*)(muiSetCallback_callback25),
	(void*)(muiSetCallback_callback26),
	(void*)(muiSetCallback_callback27),
	(void*)(muiSetCallback_callback28),
	(void*)(muiSetCallback_callback29),
	(void*)(muiSetCallback_callback30),
	(void*)(muiSetCallback_callback31),
	(void*)(muiSetCallback_callback32)
};
int mui_counter = 0;

void* mousewheel_callbacks[] = {
	(void*)(glutMouseWheelFunc_callback1),
	(void*)(glutMouseWheelFunc_callback2),
	(void*)(glutMouseWheelFunc_callback3),
	(void*)(glutMouseWheelFunc_callback4),
	(void*)(glutMouseWheelFunc_callback5),
	(void*)(glutMouseWheelFunc_callback6),
	(void*)(glutMouseWheelFunc_callback7),
	(void*)(glutMouseWheelFunc_callback8)
};
int mousewheel_counter = 0;

void* joystick_callbacks[] = {
	(void*)(glutJoystickFunc_callback1),
	(void*)(glutJoystickFunc_callback2),
	(void*)(glutJoystickFunc_callback3),
	(void*)(glutJoystickFunc_callback4),
	(void*)(glutJoystickFunc_callback5),
	(void*)(glutJoystickFunc_callback6),
	(void*)(glutJoystickFunc_callback7),
	(void*)(glutJoystickFunc_callback8)
};
int joystick_counter = 0;

/* Some other globals */
struct callback {
	int type;				/* Enumed function */
	int a;
	int b;
	int c;
	int d;
};

/* Define global callback structure */
struct callback mycallback[MAX_RETURNED_CALLBACKS];		

int sig_counter;				/* Define global counter to keep track of the signals */
int Idle_Func_Call = 0;			/* Should mainloop call IdleFunc? */ 

#ifdef WIN32

#ifdef __cplusplus
    extern "C" {
#endif
FGAPI void FGAPIENTRY reg_glutDisplayFunc(void);
FGAPI void FGAPIENTRY reg_glutOverlayDisplayFunc(void);
FGAPI void FGAPIENTRY reg_glutReshapeFunc(void);
FGAPI void FGAPIENTRY reg_glutKeyboardFunc(void);
FGAPI void FGAPIENTRY reg_glutMouseFunc(void);
FGAPI void FGAPIENTRY reg_glutMotionFunc(void);
FGAPI void FGAPIENTRY reg_glutPassiveMotionFunc(void);
FGAPI void FGAPIENTRY reg_glutVisibilityFunc(void);
FGAPI void FGAPIENTRY reg_glutEntryFunc(void);
FGAPI void FGAPIENTRY reg_glutSpecialFunc(void);
FGAPI void FGAPIENTRY reg_glutSpaceballMotionFunc(void);
FGAPI void FGAPIENTRY reg_glutSpaceballRotateFunc(void);
FGAPI void FGAPIENTRY reg_glutSpaceballButtonFunc(void);
FGAPI void FGAPIENTRY reg_glutButtonBoxFunc(void);
FGAPI void FGAPIENTRY reg_glutDialsFunc(void);
FGAPI void FGAPIENTRY reg_glutTabletMotionFunc(void);
FGAPI void FGAPIENTRY reg_glutTabletButtonFunc(void);
FGAPI int FGAPIENTRY reg_glutCreateMenu(void);
FGAPI void FGAPIENTRY reg_glutDestroyMenu(int menu);
FGAPI void FGAPIENTRY reg_glutMenuStatusFunc(void);
FGAPI void FGAPIENTRY reg_glutMenuStateFunc(void);
FGAPI void FGAPIENTRY reg_glutIdleFunc();
FGAPI void FGAPIENTRY reg_glutTimerFunc(int x, int y);
FGAPI int FGAPIENTRY glutCallback(void);
FGAPI int FGAPIENTRY glutCallbackGet(int call);
FGAPI int FGAPIENTRY glutCallbackValue(int which, int call);
FGAPI void FGAPIENTRY reg_muiSetNonMUIcallback(void);
FGAPI void FGAPIENTRY reg_muiSetCallback(int object);
FGAPI void FGAPIENTRY reg_glutMouseWheelFunc(void);
FGAPI void FGAPIENTRY reg_glutJoystickFunc(int x);
#ifdef __cplusplus
    }
#endif

#endif
